<?php
//*************************************************
//
//  dream.php ver.5.5.1 - Shift_JIS
//  dream.php        : 2023-07-16
//  dream_expand.php : 2023-12-29
//  https://a-c.2-d.jp/index/dream/
//
//*************************************************

// ݒ
define('DREAM_DEBUG', false);
dreamphp_debug();

if(!is_file(dirname(__FILE__).'/dream_fix.ini')){ die('ݒt@CKvł'); }
$dream_ini = parse_ini_file(dirname(__FILE__).'/dream_fix.ini', true);

define('DREAM_CHARSET', 'Shift_JIS');
define('DREAM_SITE', $dream_ini['site_url']);
define('DREAM_URL', 'dream.php');
define('DREAM_PHP', $_SERVER['SCRIPT_NAME']);

ini_set('default_charset', DREAM_CHARSET);
ini_set('mbstring.language', 'Japanese');
ini_set('mbstring.substitute_character', 'none');
ini_set('mbstring.input_encoding', 'pass');
ini_set('mbstring.output_encoding', 'pass');

if(is_file(dirname(__FILE__).'/dream_expand.php')){
	include_once(dirname(__FILE__).'/dream_expand.php');
}

// magic_quotes΍iPHP5.3j
function dream_stripslashes($value)
{
	$value = (is_array($value)) ? array_map('dream_stripslashes', $value) : stripslashes($value);
	return $value;
}
if (ini_get('magic_quotes_gpc'))
{
	$_POST = dream_stripslashes($_POST);
	$_COOKIE = dream_stripslashes($_COOKIE);
}

// ݒ
$dream_option['furiganaJS'] = 0;
if(is_array($dream_ini['defName']) && is_array($dream_ini['list']))
{
	if(isset($defNameOv) && !$pre_defName){ $pre_defName = $defNameOv;/*ߋ݊*/ }
	if(isset($pre_defName) && !is_array($pre_defName)){ $pre_defName= array_map('trim', explode(',', $pre_defName)); }
	$set_mode = false;
	$mode_match_url = parse_url(DREAM_PHP, PHP_URL_PATH);
	//$mode_match_url = parse_url(DREAM_PHP, PHP_URL_PATH).parse_url(DREAM_PHP, PHP_URL_QUERY);
	foreach($dream_ini['defName'] as $i => $name_list)
	{
		$name_list = array_map('trim', explode(',', $name_list));
		foreach($name_list as $a => $val){
			if(strpos($val,'==') !== false){
				list($mode_id,$mode_name) = array_map('trim', explode('==', $val));
				unset($name_list[$a]);
				$name_list[$mode_id] = $mode_name; 
				if(!preg_match("/^[0-9]+$/", $mode_id)){ $mode_name_list[] = $mode_id; }
			}
		}
		$dream_ini['defName'][$i] = $name_list;
	}
	if( isset($mode_name_list[0])){
		foreach($mode_name_list as $mode_nm){ if(preg_match("/{$mode_nm}/", $mode_match_url)){ $set_mode = $mode_nm; } }
	}
}
foreach($dream_ini['defName'] as $i => $defname){
	if(isset($pre_defName[$i]) && $pre_defName[$i] != ''){
		$dream_myName_data[$i]['defName'] = $pre_defName[$i];
	}elseif(isset($mode) && $mode !=='' && isset($defname[$mode])){
		$dream_myName_data[$i]['defName'] = $defname[$mode];
	}elseif($set_mode !== false && isset($defname[$set_mode])){
		$dream_myName_data[$i]['defName'] = $defname[$set_mode];
	}
	else{ $dream_myName_data[$i]['defName'] = $defname[0]; }
}
foreach( $dream_ini['list'] as $i => $v )
{
	$dream_myName_data[$i]['item'] = trim(str_replace('f_', '', $v));
	if(substr($v, 0, 2) === 'f_'){
		$dream_myName_data[$i]['furigana'] = 1; $dream_option['furiganaJS'] = 1;
	}
}
if(!is_null($dream_ini['changeSelect']))
{
	foreach( $dream_ini['changeSelect'] as $i => $v){ $dream_myName_data[$i]['select'] = trim($v); }
}
foreach( $dream_ini['option'] as $v => $i ) { $dream_option[$v]= $i; }
list($on_value,$off_value,$submit_value) = explode(',', $dream_option['form_value'] );
$dream_option['on_value'] = !empty($on_value) ? $on_value : 'o^';
$dream_option['off_value'] = !empty($off_value) ? $off_value : '폜';
$dream_option['submit_value'] = !empty($submit_value) ? $submit_value : 's';

// ʃwb_[
function dream_header_html()
{
	header("Content-Type: text/html; charset=".DREAM_CHARSET);
	echo '<!DOCTYPE html><meta charset="'.DREAM_CHARSET.'">';
	echo '<meta content="noindex,nofollow" name="robots">';
	echo '<meta content="width=device-width" name="viewport">';
	echo '<title>Oϊ</title>',"\n";
	if(file_exists(dirname(__FILE__)."/dream_php.css"))
	{
		echo '<style type="text/css">';
		echo file_get_contents(dirname(__FILE__)."/dream_php.css");
		echo '</style>',"\n";
	}
	echo '<body>',"\n";
}

//NbL[񑗐M폜
function dream_submit_cookie($dream_post_cookie_name=FALSE,$dream_post_cookie_data=FALSE)
{
	$site_domain = '';
	$local_check = (function_exists('mb_strpos') && mb_strpos(php_uname('n'), '***.localhost') !== false||filter_input(INPUT_SERVER, 'SERVER_NAME')=='localhost') ? true : false;
	if( DREAM_SITE!== ''){
		$cookie_url = parse_url(DREAM_SITE); 
		$site_domain = $cookie_url['host'];
	}
	$site_path = (!empty($cookie_url['path'])) ? preg_replace("/([^\/]+?)([\?#].*)?$/", '', $cookie_url['path']) : "/";
	if((isset($cookie_url['host']) && $cookie_url['host']!==$_SERVER['SERVER_NAME']) || $local_check ===true)//[J
	{
		$site_domain = ''; $site_path = '/';
	}
	if(isset($dream_post_cookie_data) && $dream_post_cookie_data != '')
	{
		setcookie($dream_post_cookie_name, $dream_post_cookie_data, time() + 60*60*24*365, $site_path, $site_domain ); 
	}
	else
	{
		setcookie($dream_post_cookie_name, '', time() - 60, $site_path, $site_domain ); 
		setcookie($dream_post_cookie_name, '', time() - 60 );
	}
}

//iNbL[Mj
dream_submit_cookie('check','1'); 

//DreamMakerł̓o^Ro[g
$cookie_name = 'Dream'.count($dream_ini['list']);
if(isset($dream_ini['option']['convert_on']) && $dream_ini['option']['convert_on'] == 1 && isset($_COOKIE[$cookie_name]) && empty($_COOKIE['myName']))
{
	$old_cookie = explode(',', $_COOKIE[$cookie_name]);
	foreach($old_cookie as $i => $v)
	{
		if(preg_match("/^(%u[0-9A-F]{4})*$/", $v))
		{
			$convert_myName[] = mb_convert_encoding(pack("H*",str_replace("%u", '', $v)), DREAM_CHARSET, "UTF-16");
		}
		else
		{
			$convert_myName[] = $v;
		}
	}
	$convert_cookie = implode(',', $convert_myName);
	dream_submit_cookie($cookie_name);
	dream_submit_cookie('myName',$convert_cookie);
}

// o^e̕ۑƍ폜
if(
	(isset($_POST['myName']) && $_POST['myName'] !== '') || 
	(isset($_POST['onName']) && $_POST['onName'] !== '')
)
{
	// o^폜
	$submit_check =
		isset($_POST['select']) && 
		(
			(($dream_option['form_submit'] === '0' || $dream_option['form_submit'] === '1' ) && $_POST['select'] === 'input') ||
			( $dream_option['form_submit'] === '2' && $_POST['select'] === $dream_option['on_value'] )
		)
		? 1 : 0;

	// `FbN
	if(function_exists('dreamphp_furigana') && $dream_option['furiganaJS']=='1'){ dreamphp_furigana($submit_check,$dream_option,$dream_myName_data); }
}

if(isset($_POST['myName']))
{
	ksort($_POST['myName']);
	$position = (isset($_POST['position']) && $_POST['position']!=='') ? explode(',', $_POST['position'] ) : '';

	// VȒlȂ}
	foreach($_POST['myName'] as $i => $v)
	{
		if($v !== $dream_myName_data[$i]['item'] && $v !== "o^" && $v !== $dream_myName_data[$i]['defName'])
		{
			
			$input_dream_myName_data[$i] = (isset($_POST['position']) && in_array($i, $position) && $submit_check == 0) ? '' : $v; 
		}
		else
		{
			$input_dream_myName_data[$i] = '';
		}
	}

	//o^
	if((isset($_POST['position']) && $_POST['position'] !== '') || $submit_check === 1)
	{
		$dream_my_cookie = implode(',', $input_dream_myName_data);
		dream_submit_cookie('myName');
		dream_submit_cookie('myName',$dream_my_cookie);
	}
	//폜
	elseif((empty($_POST['position']) || $_POST['position'] = '') && $submit_check === 0)
	{
		dream_submit_cookie('myName');
	}

	//y[WXV
	$ref = (isset($_SERVER['REQUEST_URI'])) ? $_SERVER['REQUEST_URI'] : '';
	if(isset($_COOKIE['check']) && $_COOKIE['check']==='1')
	{
		if(isset($ref) && $ref !== ''){ header("Location:{$ref}");  exit; }
	}
	else
	{
		dream_header_html();
		echo 'cookieɑΉĂȂł͖Oۑł܂B';
		if($dream_option['post_on'] !== '0'){ echo 'i̊ey[WŕϊĂB'; }
		else{ echo 'ῗł܂񂪁AftHgły݂B'; }
		echo '<ul><li>uEUobOŌ̃y[Wɖ߂ĂB</ul>';
		exit;
	}
}

//O
if($dream_option['post_on']  && isset($_POST['onName']) && empty($_POST['noChange']))
{
	ksort($_POST['onName']);
	$myName_data = $_POST['onName']; //|Xg΃|Xg
}
elseif( isset($convert_myName) && $convert_myName[0] !== '' ) 
{
	$dreamName_data= $convert_myName; //DreamMakerCookie΂
}
elseif(isset($_COOKIE['myName']) && $_COOKIE['myName'] !== '')
{
	$myName_data= explode(',', $_COOKIE['myName']); //NbL[΃NbL[
}
foreach($dream_myName_data as $i => $v)
{
	if(isset($v['defName'])){
		if(isset($myName_data) && isset($myName_data[$i]) && $myName_data[$i]!=='')
		{
			$dream_myName_data[$i]['set'] = str_replace(PHP_EOL, "", $myName_data[$i]);
		}
		else{
			$dream_myName_data[$i]['set'] = $dream_myName_data[$i]['defName'];
		}
	}
	else{ unset($dream_myName_data[$i]); }
}

//Oo
function myName($no='0',$own_def=FALSE)
{
	global $dream_myName_data;
	$no = trim($no);
	$myname = '<strong>ERROR</strong>';
	if(
		isset($dream_myName_data[$no]) &&
		$dream_myName_data[$no]['defName'] == $dream_myName_data[$no]['set'] && 
		$own_def !== FALSE && $own_def !== ''
	){
		$myname = $own_def;
	}
	elseif(isset($dream_myName_data[$no]['set']) && $dream_myName_data[$no]['set'] !== '')
	{
		$myname = htmlspecialchars($dream_myName_data[$no]['set'],ENT_QUOTES,DREAM_CHARSET);
	}
	echo $myname;
}


// tH[o
function nameForm( $small_form=NULL,$this_action=NULL,$dream_myName_data=FALSE,$dream_option=FALSE,$mode=FALSE )
{
	global $dream_myName_data, $dream_option;
	static $dreamform_exe_num = 0;
	$dream_form = '';

	//XHTMLp
	$end = ($dream_option['form_output'] === '1') ? ' /' : '';
	$post_action = ($dream_option['form_output'] === '1') ? ' action=""' : '';

	//POSTϊp
	if($mode=='post_on' || (isset($_POST['onName']) && is_array($_POST['onName'])))
	{
		$formClass = 'changeName dreamForm2';
		$posted = 'onName';
		$dream_option['form_first'] = '2';
		$read = '<p><input type="submit" name="noChange" value="ϊɓǂ"'.$end.'></p>';
	}
	else
	{
		$formClass = 'changeName dreamForm1';
		$posted = 'myName';
	}

	//l
	foreach( $dream_myName_data as $no => $v)
	{
		if($dream_option['form_first'] === '0')
		{
			$def_value[$no] = (isset($dream_myName_data[$no]['item'])) ? $dream_myName_data[$no]['item'] : '';
		}
		elseif($dream_option['form_first'] === '1'){ $def_value[$no] = 'o^'; }
		elseif($dream_option['form_first'] === '2'){ $def_value[$no] = ''; }
		elseif($dream_option['form_first'] === '3'){ $def_value[$no] = $dream_myName_data[$no]['defName']; }
	}
	foreach( $def_value as $no => $item )
	{
		if($mode == 'furigana')
		{
			if($_POST['myName'])
			{
				$value[$no] = ($item == $_POST['myName'][$no]) ? $item : $_POST['myName'][$no];
			}
			elseif($_POST['onName'])
			{
				$value[$no] = ($item == $_POST['onName'][$no]) ? $item : $_POST['onName'][$no];
			}
			$yet[$no] = 0;
		}
		elseif(
			isset($dream_myName_data[$no]['set']) &&
			$dream_myName_data[$no]['set'] == $dream_myName_data[$no]['defName']
		){
			$value[$no] =  $item;
			$yet[$no] = 0;
		}
		else
		{
			$value[$no] = $dream_myName_data[$no]['set'];
			$yet[$no] = 1;
		}
	}

	//tH[o͂̐ݒ
	$onForm = '';
	if(isset($small_form) && $small_form !==''){ $onForm = $small_form; }
	elseif(isset($_POST['position']) && $_POST['position'] !==''){ $onForm = $_POST['position']; }
	$vn = (isset($onForm) && $onForm !== '') ?  explode(',',$onForm) : NULL;

	//gp^O
	if($dream_option['form_type'] === '0')
	{
		$useTag = array( '<ul><!--', '--></ul>', '--><li>', '', "</li><!--\n" );
	}
	elseif($dream_option['form_type'] === '1')
	{
		$useTag = array( '<table summary="̓tH[">', '</table>', '<tr><th>', '</th><td>', "</td></tr>\n" );
	}
	$exe_num_over = ($dreamform_exe_num>0) ? $dreamform_exe_num.'_' : '';

	// Js
	if($dream_option['post_on'] !== '0'){ $noCookie = 'i̊ey[WŕϊĂB'; }
	else{ $noCookie = 'ftHgły݂B'; }
	if($dreamform_exe_num === 0){ 
		$dream_form .= '<script type="text/javascript"><!--'."\n";
		$dream_form_js = <<<EOD
document.addEventListener('DOMContentLoaded', (event) => {
	if (!navigator.cookieEnabled) {
		const dreamNoCookieElement = document.createElement("p");
		const dreamNoCookieContent = document.createTextNode("CookieLɂ邩A{$noCookie}"); 
		dreamNoCookieElement.appendChild(dreamNoCookieContent); 
		dreamNoCookieElement.setAttribute("class","dream-noCookie");
		const dreamForm = document.querySelector('form.dreamForm1');
		dreamForm.prepend(dreamNoCookieElement); 
	}
});
EOD;
		if(function_exists('furiJS') && $dream_option['furiganaJS']=='1'){
			$dream_form_js .= furiJS($dream_option, $dream_myName_data);
		}
		$dream_form_js = preg_replace('/\s+/', "\x20", $dream_form_js);
		$dream_form_js = preg_replace("/\x23.*/", '', $dream_form_js);
		$dream_form_js = preg_replace('/\?>$/s', '', $dream_form_js);
		$dream_form .= $dream_form_js;
		$dream_form .= "\n".'--></script>'."\n";
	}

	//\
	$dream_form .= '<form method="post" class="'.$formClass.'"'.$post_action .'>'."\n";
	if(isset($read)){ $dream_form .= $read; }
	$dream_form .= '<fieldset><legend>';
	$dream_form .= ($mode=="furigana")? 'ē' : 'Oϊ';
	$dream_form .= '</legend>'."\n".$useTag[0]."\n";

	foreach( $dream_myName_data as $no => $dream_data )
	{
		$class = ($yet[$no] === 1) ? ' class="yet"' : '';
		if( $vn == NULL || $vn[0] === '' || ( is_array($vn) && in_array($no,$vn)) )
		{
			//x
			if(isset($dream_data['item']) && $dream_data['item'] !== '')
			{
				$label = ($dream_data['item'] !== '') ? $dream_data['item'] : 'ϊ'.($no+1);
				$dream_form .= $useTag[2];
				$dream_form .= '<label for="NAME-INPUT'.$exe_num_over.$no.'"';
				if(isset($dream_data['furigana'])){ $dream_form .= ' class="dream-furigana"'; }
				$dream_form .= '>'.$dream_data['item'].'</label>';
				$dream_form .= $useTag[3];
			}

			//I
			if(isset($dream_data['select']))
			{
				$select_option = explode(',', $dream_data['select'] );
				$dream_form .= '<select id="NAME-INPUT'.$exe_num_over.$no.'" name="'.$posted.'['.$no.']"'.$class.'>';
				foreach($select_option as $i => $v)
				{
					$dream_form .= '<option value="'.$v.'"';
					if(isset($dream_data['set']) && $dream_data['set']== $v){ $dream_form .= ' selected="selected"'; }
					$dream_form .= '>'.$v.'</option>';
				}
				$dream_form .= '</select>';
			}
			
			//
			else
			{
				$onblur = (isset($dream_data['furigana'])) ? 'check(this);' : '';

				// JavaScript}
				if($dream_option['form_focus'] === '1')
				{
					$onfocus = ' onfocus="this.select()"';
					if(isset($onblur)){ $onfocus .=  ' onblur="'.$onblur.'"'; }
				}
				elseif($dream_option['form_focus'] === '2')
				{
					$onfocus = " onfocus=\"if(this.value=='{$value[$no]}'){this.value='';}\" onblur=\"{$onblur}if(this.value==''){this.value='{$value[$no]}';}\"";
				}
				else
				{
					$onfocus = (isset($onblur) && $onblur !== '') ? ' onblur="'.$onblur.'"' : '';
				}

				$dream_form .= '<input type="text" size="16" maxlength="16" id="NAME-INPUT'.$exe_num_over.$no.'" name="'.$posted.'['.$no.']" value="'.$value[$no].'"'.$onfocus.$class.$end.'>';
			}
			$dream_form .= $useTag[4];
		}
	}
	$dream_form .= $useTag[1]."\n";

	// \
	if(is_array($vn) && $vn[0] !== '')
	{
		foreach( $dream_myName_data as $no => $item )
		{
			if(!in_array($no,$vn))
			{
				$dream_form .= '<input type="hidden" name="'.$posted.'['.$no.']" value="'.$value[$no].'"'.$end.'>';
			}
		}
		$dream_form .= '<input type="hidden" name="position" value="'.$small_form.'"'.$end.'>';
	}
	if($posted == 'onName'){
		$dream_form .= <<<__EOD
<ul class="process">
	<li><input type="submit" name="select" class="dream_set" value="ϊēǂ"{$end}></li>
</ul>
__EOD;
	}
	else{
		switch(true)
		{
			case $dream_option['form_submit'] === '0': // <select>
			$dream_form .= <<<__EOD

<p class="process"><select name="select" id="PROCESS">
<option value="input">{$dream_option['on_value']}</option>
<option value="reset">{$dream_option['off_value']}</option>
</select>
<input type="submit" name="input" class="dream_set" value="{$dream_option['submit_value']}"{$end}></p>

__EOD;
			break;

			case $dream_option['form_submit'] === '1': // radio
			$dream_form .= <<<__EOD

<ul class="process">
	<li><label><input type="radio" name="select" value="input" checked="checked"{$end}>{$dream_option['on_value']}</label></li><!--
	--><li><label><input type="radio" name="select" value="reset"{$end}>{$dream_option['off_value']}</label></li>
</ul>
<p class="process"><input type="submit" name="input" class="dream_set" value="{$dream_option['submit_value']}"{$end}></p>

__EOD;
			break;
	
			case $dream_option['form_submit'] === '2': // button
			$dream_form .= <<<__EOD

<ul class="process">
	<li><input type="submit" name="select" class="dream_set" value="{$dream_option['on_value']}"{$end}></li><!--
	--><li><input type="submit" name="select" class="dream_set" value="{$dream_option['off_value']}"{$end}></li>
</ul>

__EOD;
			break;
		}
	}
	$dream_form .= '</fieldset>'."\n".'</form>'."\n";

	echo $dream_form;
	$dreamform_exe_num = ++$dreamform_exe_num;
}


// fobO
function dreamphp_debug(){
	if(DREAM_DEBUG === true)
	{
		ini_set('display_errors',1);
		ini_set('display_startup_errors',1);
		error_reporting(E_ALL);
	}
	else{
		ini_set('display_errors',0);
		ini_set('display_startup_errors',0);
		error_reporting(0);
	}
}

if(!function_exists('CmyName')){
	function CmyName($no='', $type='', $kigou='',$pre=''){
		echo '<strong>ERROR</strong>';
	}
}

// o
$dreamphp_include = get_included_files();
if (array_shift($dreamphp_include)===__FILE__)
{
	if($_SERVER['QUERY_STRING'] === 'form')
	{
		dream_header_html();
		nameForm();
		exit;
	}
	else{ die(); }
}
else
{
	if(function_exists('offForm') && $dream_option['post_on'] === '2' && empty($noForm))
	{
		offForm(); 
	}
}
?>